import globalProgressBar from './GlobalProgressBar'
import config from './GlobalProgressBar.config'

export default {
  
  progressBarInstance: null,

  install(Vue, opts) {

    Object.assign(config, opts)

    const globalProgressBarConstructor = Vue.extend(globalProgressBar)

    this.progressBarInstance = new globalProgressBarConstructor().$mount()
    document.body.appendChild(this.progressBarInstance.$el)

    const emit = eventName => this.progressBarInstance.$emit(eventName)

    Vue.$progress = Vue.prototype.$progress = {
      start: () => emit('start'),
      finish: () => emit('finish'),
      error: () => emit('errorFinish'),
      warning: () => emit('warningFinish'),
      success: () => emit('successFinish')
    }

  }
}